#ifndef __TOAST_LOGGER_USERFIELDS__
#define __TOAST_LOGGER_USERFIELDS__

#ifdef TOASTLOGGER_EXPORTS
#define TOASTLOGGER_API     __declspec(dllexport)
#else
#define TOASTLOGGER_API     __declspec(dllimport)
#endif


#include <windows.h>
#include <stdio.h>
#include <malloc.h>

namespace toast
{
    namespace logger
    {
        class TOASTLOGGER_API ToastLoggerUserFields
        {
        public:
            virtual void insert(const char* key, const char* value) = 0;
            virtual void insert(const wchar_t* key, const wchar_t* value) = 0;

            virtual void erase(const char* key) = 0;
            virtual void erase(const wchar_t* key) = 0;

            virtual bool find(const char* key) = 0;
            virtual bool find(const wchar_t* key) = 0;

            virtual int size() = 0;
            virtual bool empty() = 0;

            virtual void clear() = 0;
        };
    }
}

extern "C" TOASTLOGGER_API toast::logger::ToastLoggerUserFields* CreateToastLoggerUserFields();
extern "C" TOASTLOGGER_API void DestroyToastLoggerUserFields(toast::logger::ToastLoggerUserFields* userFields);


#endif  //__TOAST_LOGGER_USERFIELDS__