#pragma once

// toast sdk 
#include "toast/ToastLogger.h"

using namespace toast::logger;
using namespace std;

class ToastLoggerManager
{
public:
	static void ToastLoggerManager::InitializeSdk(const char* appkey,
										const char* version,
										TOAST_SERVICE_ZONE serviceZone,
										bool enableCrashReport,
										bool enableCrashSilenceMode,
										bool enableGDPRFilter,
										TOAST_LANGUAGE_TYPE langType, 
										const wchar_t* dialogMessage);

public:
	static void SendInfo(const char* message);
	static void SendDebug(const char* message);
	static void SendWarn(const char* message);
	static void SendError(const char* message);
	static void SendFatal(const char* message);

public:
	static void InsertUserField(const char* key, const char* value);
	static void DeleteUserField(const char* key);
	static void ClearUserField();
	static bool FindUserField(const char* key);
public :
	static void InsertGlobalField(const char* key, const char* value);
	static void DeleteGlobalField(const char* key);
	static void ClearGlobalField();

private :
	static void InternalSend(TOAST_LOGGER_LEVEL level, const char* message);
	static void CreateUserField();

private :
	static ToastLogger* _logger;
	static ToastLoggerUserFields* _userFieldMap;
};

